{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}
Program Hook_demo;
uses jsdoor,jsmisc,crt,asmmisc;
Const
  product = 'Hook Demo';
  version = '1.00a';
  release = 'Gamma';
  author  = 'John Stephenson';
var
  jsrhooko: pointer;

Procedure Updatetime; far;
var
  attr: byte;
Const
  lastsec: byte = 0;
  { Unknown to little, a typed constant in a procedure is not stored in  }
  { the stack, but rather in the data segment, meaning it's not reinit'd }
  { when the procedure restarts.                                         }
begin
  attr := textattr;
  textattr := lightgray shl 4;
  with time do begin
    { So it's not updated more than once a second }
    if lastsec <> sec then begin
      putstring(8,maxheight,lzero(hour)+':'+lzero(min)+':'+lzero(sec));
      putstring(32,maxheight,strfunc((timetoexpire-seconds) div 60)+' ');
      lastsec := sec;
    end;
  end;
  textattr := attr;
  calluserproc(jsrhooko);
end;

var jsr_old_hook: pointer;
Procedure MyTimeSlice; far;
begin
  timeslice;
  if jsr_old_hook <> nil then calluserproc(jsr_old_hook);
end;

Procedure MySplitScreen; far;
begin
  if snoop = true then SaveScreen('Screen.tmp',1,1,80,hi(windmax)+1);
  splitscreen;
  if snoop = true then begin
    dispfile('Screen.tmp',1);
    ferase('Screen.tmp');
  end;
end;

Procedure DrawStatusBar(dorsys : doorsystype);
var org : array[1..3] of byte;
begin
  { Save current position }
  org[1] := wherex;
  org[2] := wherey;
  org[3] := textattr;
  { Draw status bar }
  with dorsys do begin
    textattr := lightgray shl 4;
    { Fill the line with colour }
    Gotoxy(1, maxheight-1); clreol;
    { Write all the info }
    gotoxy(2, maxheight-1); write('User: ',username);
    gotoxy(24, maxheight-1); write('Bps: ',baudrate);
    gotoxy(36, maxheight-1); write('Node: ',node);
    gotoxy(45, maxheight-1); write('Access: ',access, '  ');
    gotoxy(57, maxheight-1); write('Com: ',comport);
    gotoxy(65, maxheight-1);
    write('F1 Exit F4 Chat');
    gotoxy(1,maxheight); clreol;
    gotoxy(2,maxheight); write('Time: ');
    gotoxy(24,maxheight); write('Remain: ');
    gotoxy(45,maxheight); write(product+' by '+author);
  end;
  window(1,1,maxwidth,maxheight-2);
  { Restore, taking into account that the maxheight changed }
  if org[2] > maxheight-1 then dec(org[2]);
  gotoxy(org[1], org[2]);
  textattr := org[3];
end;

Procedure Finish; far;
var org : array[1..2] of byte;
begin
  org[1] := wherex;
  org[2] := wherey;
  window(1,1,maxwidth,maxheight);
  textattr := lightgray;
  gotoxy(1,maxheight); clreol;
  gotoxy(1,maxheight-1); clreol;
  gotoxy(org[1], org[2]);
  halt(0);
end;

begin
  { Init the hooks }
  jsr_old_hook := jsrhook;
  jsrhook := @mytimeslice;
  { Then }
  jsrhooko := jsrhook;
  jsrhook := @updatetime;

  chatproc := @MySplitScreen;
  finishup := @finish;
  { Set up status bar, in a way that the time is at the bottom line, 20th
   column, or change the above }
  fakedoorsys(doorsys);
  DrawStatusBar(doorsys);

  jsclrscr;
  jswriteln(avtred+'An advantage to '+avtlightred+'hooking'+avtred+' this way, instead of making your own JSReadkey');
  jswriteln('procedure is simple. It allows you to hook it in a way that allows you to');
  jswriteln('use the "hooked" version of jsreadkey '+avtlightred+'inside'+avtred+' the jsdoor unit!'+enter);
  jswrite('Enter some text: '+avtlightred);
  nameinput(40,'No thanks :>');
  { Also: IPC can be chained in this way. Offering a great advantage to
    the old method of replacing the entire readkey function }
  finish;
end.
